| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
RootHistCnv::RFileCnv Class Reference

NTuple converter class definition. More...

`#include <src/RFileCnv.h>`

Inheritance diagram for RootHistCnv::RFileCnv:
[legend]
Collaboration diagram for RootHistCnv::RFileCnv:
[legend]

## Public Member Functions
StatusCode | initialize () override
| Initialise. More...
StatusCode | createObj (IOpaqueAddress *pAddress, DataObject *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | createRep (DataObject *pObject, IOpaqueAddress *&refpAddress) override
| Convert the transient object to the requested representation. More...
StatusCode | updateRep (IOpaqueAddress *pAddress, DataObject *pObject) override
| Convert the transient object to the requested representation. More...
| RFileCnv (ISvcLocator *svc)
| Standard constructor. More...
Public Member Functions inherited from RootHistCnv::RDirectoryCnv
StatusCode | createObj (IOpaqueAddress *pAddr, DataObject *&refpObj) override
| Create the transient representation of an object. More...
StatusCode | fillObjRefs (IOpaqueAddress *pAddr, DataObject *refpObj) override
| Update the transient object from the other representation. More...
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
StatusCode | updateRep (IOpaqueAddress *pAddr, DataObject *pObject) override
| Convert the transient object to the requested representation. More...
| RDirectoryCnv (ISvcLocator *svc)
| Standard constructor. More...
| RDirectoryCnv (ISvcLocator *svc, const CLID &clid)
| Standard constructor. More...
Public Member Functions inherited from RootHistCnv::RConverter
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
long | repSvcType () const override
StatusCode | error (const std::string &msg)
StatusCode | regTFile (const std::string, const TFile *)
StatusCode | findTFile (const std::string, TFile *&)
std::string | diskDirectory (const std::string &loc)
std::string | directory (const std::string &loc)
void | setDirectory (const std::string &loc)
void | setDiskDirectory (const std::string &loc)
StatusCode | createDirectory (const std::string &loc)
StatusCode | createDiskDirectory (const std::string &loc)
std::string | getDirectory ()
std::string | convertId (const std::string &) const
Public Member Functions inherited from Converter
StatusCode | initialize () override
| Initialize the converter. More...
StatusCode | finalize () override
| Initialize the converter. More...
StatusCode | setDataProvider (IDataProviderSvc *svc) override
| Set Data provider service. More...
SmartIF< IDataProviderSvc > & | dataProvider () const override
| Get Data provider service. More...
StatusCode | setConversionSvc (IConversionSvc *svc) override
| Set conversion service the converter is connected to. More...
SmartIF< IConversionSvc > & | conversionSvc () const override
| Get conversion service the converter is connected to. More...
StatusCode | setAddressCreator (IAddressCreator *creator) override
| Set address creator facility. More...
SmartIF< IAddressCreator > & | addressCreator () const override
| Retrieve address creator facility. More...
const CLID & | objType () const override
| Retrieve the class type of objects the converter produces. More...
virtual long | i_repSvcType () const
| Retrieve the class type of the data store the converter uses. More...
StatusCode | createObj (IOpaqueAddress *pAddress, DataObject *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | fillObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the created transient object. More...
StatusCode | updateObj (IOpaqueAddress *pAddress, DataObject *refpObject) override
| Update the transient object from the other representation. More...
StatusCode | updateObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an updated transient object. More...
StatusCode | createRep (DataObject *pObject, IOpaqueAddress *&refpAddress) override
| Convert the transient object to the requested representation. More...
StatusCode | fillRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the converted object. More...
StatusCode | updateRep (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the converted representation of a transient object. More...
StatusCode | updateRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an already converted object. More...
| Converter (long storage_type, const CLID &class_type, ISvcLocator *svc=0)
| Standard Constructor. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &type, const std::string &name, T *&psvc) const
| Access a service by name, type creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true) const
| Return a pointer to the service identified by name (or "type/name") More...
Public Member Functions inherited from implements< IConverter >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| implements ()=default
| Default constructor. More...
| implements (const implements &)
| Copy constructor (zero the reference count) More...
implements & | operator= (const implements &)
| Assignment operator (do not touch the reference count). More...
unsigned long | addRef () override
| Reference Interface instance. More...
unsigned long | release () override
| Release Interface instance. More...
unsigned long | refCount () const override
| Current reference count. More...

## Static Public Member Functions
static const CLID & | classID ()
| Inquire class type. More...
Static Public Member Functions inherited from RootHistCnv::RDirectoryCnv
static const CLID & | classID ()
| Inquire class type. More...
Static Public Member Functions inherited from RootHistCnv::RConverter
static long | storageType ()
| Inquire storage type. More...

## Protected Attributes
TFile * | rfile
| Pointer to ROOT file. More...
std::string | m_compLevel
| Compression setting, property RFileCnv.GlobalCompression. More...
Protected Attributes inherited from implements< IConverter >
std::atomic_ulong | m_refCount
| Reference counter. More...

## Additional Inherited Members
Public Types inherited from Converter
using | Factory = Gaudi::PluginService::Factory< IConverter *(ISvcLocator *)>
Public Types inherited from implements< IConverter >
using | base_class = implements< Interfaces... >
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
using | iids = typename extend_interfaces_base::ext_iids
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from RootHistCnv::RConverter
| RConverter (const CLID &clid, ISvcLocator *svc)
| Standard constructor. More...
virtual StatusCode | readObject (IOpaqueAddress *pAddr, DataObject *&refpObj)
| Create the transient representation of an object. More...
virtual TObject * | createPersistent (DataObject *pObj)
| Create the persistent representation of an object. More...
StatusCode | createAddress (DataObject *pObject, TDirectory *pDir, TObject *pTObject, IOpaqueAddress *&refpAddr)
| Create address of the transient object according to the requested representation. More...
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, long id, TObject *pTobj, IOpaqueAddress *&refpAddress)
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, const std::string &title, TObject *pTobj, IOpaqueAddress *&refpAddress)
TDirectory * | changeDirectory (DataObject *pObject)
| Switch to object directory (=Parent directory) More...
Protected Member Functions inherited from Converter
SmartIF< ISvcLocator > & | serviceLocator () const
| Retrieve pointer to service locator. More...
SmartIF< IMessageSvc > & | msgSvc () const
| Retrieve pointer to message service. More...
SmartIF< IDataManagerSvc > & | dataManager () const
| Get Data Manager service. More...

## Detailed Description

NTuple converter class definition.

- Major cleanup and debugging for Gaudi v9
- Removal of all static storage

Author
  Charles Leggett
  Markus Frank

Definition at line 22 of file RFileCnv.h.

## Constructor & Destructor Documentation

## ◆ RFileCnv()

RootHistCnv::RFileCnv::RFileCnv | ( | ISvcLocator * | svc | ) |

Standard constructor.

Definition at line 25 of file RFileCnv.cpp.

25 : RDirectoryCnv( svc, classID() ) {}
RootHistCnv::RFileCnv::classID
static const CLID & classID()
Inquire class type.
Definition: RFileCnv.h:38
RootHistCnv::RDirectoryCnv::RDirectoryCnv
RDirectoryCnv(ISvcLocator *svc)
Standard constructor.
Definition: RDirectoryCnv.h:29

## Member Function Documentation

## ◆ classID()

static const CLID& RootHistCnv::RFileCnv::classID | ( |  | ) |
| inline static

Inquire class type.

Definition at line 38 of file RFileCnv.h.

38 { return CLID_NTupleFile; }

## ◆ createObj()

StatusCode RootHistCnv::RFileCnv::createObj | ( | IOpaqueAddress * | pAddress,
|  | DataObject *& | refpObject
| ) |  |
| override

Create the transient representation of an object.

Definition at line 41 of file RFileCnv.cpp.

43 {
44 MsgStream log( msgSvc(), "RFileCnv" );
45 unsigned long* ipar = (unsigned long*)pAddress->ipar();
46 char mode[2] = {char( ipar[1] ), 0};
47
48 std::string fname = pAddress->par()[0]; // Container name
49 std::string ooname = pAddress->par()[1]; // Object name
50
51 const std::string* spar = pAddress->par();
52 // Strip of store name to get the top level RZ directory
53 std::string oname = spar[1].substr( spar[1].find( "/", 1 ) + 1 );
54
55 // Protect against multiple instances of TROOT
56 if ( !gROOT ) {
57 static TROOT root( "root", "ROOT I/O" );
58 // gDebug = 99;
59 } else {
60 log << MSG::VERBOSE << "ROOT already initialized, debug = " << gDebug << endmsg;
61 }
62
63 // Determine access mode:
64
65 if ( mode[0] == 'O' ) {
66
67 if ( findTFile( ooname, rfile ).isFailure() ) {
68
69 log << MSG::INFO << "opening Root file \"" << fname << "\" for reading" << endmsg;
70
71 rfile = TFile::Open( fname.c_str(), "READ" );
72 if ( rfile && rfile->IsOpen() ) {
73 regTFile( ooname, rfile ).ignore();
74
75 ipar[0] = (unsigned long)rfile;
76 NTuple::File* pFile = new NTuple::File( objType(), fname, oname );
77 pFile->setOpen( true );
78 refpObject = pFile;
79
80 return StatusCode::SUCCESS;
81
82 } else {
83 log << MSG::ERROR << "Couldn't open \"" << fname << "\" for reading" << endmsg;
84 return StatusCode::FAILURE;
85 }
86
87 } else {
88 log << MSG::DEBUG << "Root file \"" << fname << "\" already opened" << endmsg;
89 return StatusCode::SUCCESS;
90 }
91
92 } else if ( mode[0] == 'U' ) {
93
94 log << MSG::INFO << "opening Root file \"" << fname << "\" for updating" << endmsg;
95
96 log << MSG::ERROR << "don't know how to do this yet. Aborting." << endmsg;
97 exit( 1 );
98
99 } else if ( mode[0] == 'N' ) {
100
101 log << MSG::INFO << "opening Root file \"" << fname << "\" for writing";
102 if ( !m_compLevel.empty() ) { log << ", CompressionLevel='" << m_compLevel << "'"; }
103 log << endmsg;
104
105 rfile = TFile::Open( fname.c_str(), "RECREATE", "Gaudi Trees" );
106 if ( !( rfile && rfile->IsOpen() ) ) {
107 log << MSG::ERROR << "Could not open file " << fname << " for writing" << endmsg;
108 return StatusCode::FAILURE;
109 }
110 if ( !m_compLevel.empty() ) {
111 const RootCompressionSettings settings( m_compLevel );
112 rfile->SetCompressionSettings( settings.level() );
113 }
114
115 regTFile( ooname, rfile ).ignore();
116
117 log << MSG::DEBUG << "creating ROOT file " << fname << endmsg;
118
119 ipar[0] = (unsigned long)rfile;
120 NTuple::File* pFile = new NTuple::File( objType(), fname, oname );
121 pFile->setOpen( true );
122 refpObject = pFile;
123 return StatusCode::SUCCESS;
124
125 } else {
126
127 log << MSG::ERROR << "Uknown mode to access ROOT file" << endmsg;
128 return StatusCode::FAILURE;
129 }
130
131 return StatusCode::FAILURE;
132 }
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
std::string::empty
T empty(T... args)
NTuple::File::setOpen
void setOpen(bool flag)
Set "open" flag.
Definition: NTuple.h:944
RootHistCnv::RFileCnv::rfile
TFile * rfile
Pointer to ROOT file.
Definition: RFileCnv.h:44
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
RootHistCnv::RConverter::regTFile
StatusCode regTFile(const std::string, const TFile *)
Definition: RConverter.cpp:264
RootHistCnv::RConverter::findTFile
StatusCode findTFile(const std::string, TFile *&)
Definition: RConverter.cpp:279
MSG::VERBOSE
Definition: IMessageSvc.h:15
std::string
STL class.
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:95
std::exit
T exit(T... args)
RootHistCnv::RFileCnv::m_compLevel
std::string m_compLevel
Compression setting, property RFileCnv.GlobalCompression.
Definition: RFileCnv.h:45
std::find
T find(T... args)
StatusCode::ignore
const StatusCode & ignore() const
Ignore/check StatusCode.
Definition: StatusCode.h:153
std::string::c_str
T c_str(T... args)
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
MSG::ERROR
Definition: IMessageSvc.h:15
std::string::substr
T substr(T... args)
gaudiComponentHelp.root
root
Definition: gaudiComponentHelp.py:27
MSG::INFO
Definition: IMessageSvc.h:15
IOpaqueAddress::ipar
virtual const unsigned long * ipar() const =0
Access to generic link parameters.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
Converter::objType
const CLID & objType() const override
Retrieve the class type of objects the converter produces.
Definition: Converter.cpp:13
NTuple::File
Small class representing an N tuple file in the transient store.
Definition: NTuple.h:910
Gaudi.Configuration.log
log
Definition: Configuration.py:13

## ◆ createRep()

StatusCode RootHistCnv::RFileCnv::createRep | ( | DataObject * | pObject,
|  | IOpaqueAddress *& | refpAddress
| ) |  |
| override

Convert the transient object to the requested representation.

Definition at line 135 of file RFileCnv.cpp.

137 {
138 refpAddress = pObject->registry()->address();
139 return RFileCnv::updateRep( refpAddress, pObject );
140 }
DataObject::registry
IRegistry * registry() const
Get pointer to Registry.
Definition: DataObject.h:72
RootHistCnv::RFileCnv::updateRep
StatusCode updateRep(IOpaqueAddress *pAddress, DataObject *pObject) override
Convert the transient object to the requested representation.
Definition: RFileCnv.cpp:143
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.

## ◆ initialize()

StatusCode RootHistCnv::RFileCnv::initialize | ( |  | ) |
| override

Initialise.

Definition at line 28 of file RFileCnv.cpp.

28 {
29 // Set compression level property ...
30 ISvcLocator* svcLoc = Gaudi::svcLocator();
31 auto jobSvc = svcLoc->service<IJobOptionsSvc>( "JobOptionsSvc" );
32 auto prop = jobSvc->getClientProperty( "RFileCnv", "GlobalCompression" );
33 if ( prop ) m_compLevel = prop->toString();
34
35 // initialise base class
36 return RDirectoryCnv::initialize();
37 }
ISvcLocator
The ISvcLocator is the interface implemented by the Service Factory in the Application Manager to loc...
Definition: ISvcLocator.h:25
Converter::initialize
StatusCode initialize() override
Initialize the converter.
Definition: Converter.cpp:43
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:76
IJobOptionsSvc
Main interface for the JobOptions service.
Definition: IJobOptionsSvc.h:20
Gaudi::svcLocator
GAUDI_API ISvcLocator * svcLocator()
RootHistCnv::RFileCnv::m_compLevel
std::string m_compLevel
Compression setting, property RFileCnv.GlobalCompression.
Definition: RFileCnv.h:45
IJobOptionsSvc::getClientProperty
virtual const Gaudi::Details::PropertyBase * getClientProperty(const std::string &client, const std::string &name) const =0
Get a property for a client.

## ◆ updateRep()

StatusCode RootHistCnv::RFileCnv::updateRep | ( | IOpaqueAddress * | pAddress,
|  | DataObject * | pObject
| ) |  |
| override

Convert the transient object to the requested representation.

Definition at line 143 of file RFileCnv.cpp.

145 {
146 MsgStream log( msgSvc(), "RFileCnv" );
147 std::string ooname = pAddress->par()[1];
148
149 NTuple::File* pFile = dynamic_cast<NTuple::File*>( pObject );
150 if ( pFile && pFile->isOpen() ) {
151
152 unsigned long* ipar = (unsigned long*)pAddress->ipar();
153 if ( findTFile( ooname, rfile ).isFailure() ) {
154 log << MSG::ERROR << "Problems closing TFile " << ooname << endmsg;
155 return StatusCode::FAILURE;
156 }
157
158 rfile->Write( nullptr, TObject::kOverwrite );
159 if ( log.level() <= MSG::INFO ) {
160 log << MSG::INFO << "dumping contents of " << ooname << endmsg;
161 rfile->Print();
162 }
163
164 /*
165 * MetaData
166 * Ana Trisovic
167 * March 2015
168 * */
169 SmartIF<IMetaDataSvc> mds;
170 mds = serviceLocator()->service( "Gaudi::MetaDataSvc", false );
171 // auto mds = service<IMetaDataSvc>("MetaDataSvc", false);
172 if ( mds ) {
173 std::map<std::string, std::string> m_metadata = mds->getMetaDataMap();
174 if ( !rfile->WriteObject( &m_metadata, "info" ) ) { return StatusCode::FAILURE; }
175 }
176 /* */
177
178 rfile->Close();
179 delete rfile;
180
181 ipar[0] = 0;
182 pFile->setOpen( false );
183 return StatusCode::SUCCESS;
184
185 } else {
186 log << MSG::ERROR << "TFile " << ooname << " is not open" << endmsg;
187 }
188 return StatusCode::FAILURE;
189 }
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
SmartIF
Small smart pointer class with automatic reference counting for IInterface.
Definition: IConverter.h:15
NTuple::File::setOpen
void setOpen(bool flag)
Set "open" flag.
Definition: NTuple.h:944
RootHistCnv::RFileCnv::rfile
TFile * rfile
Pointer to ROOT file.
Definition: RFileCnv.h:44
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
IMetaDataSvc::getMetaDataMap
virtual std::map< std::string, std::string > getMetaDataMap() const =0
RootHistCnv::RConverter::findTFile
StatusCode findTFile(const std::string, TFile *&)
Definition: RConverter.cpp:279
std::map< std::string, std::string >
std::string
STL class.
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:95
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:76
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
MSG::ERROR
Definition: IMessageSvc.h:15
NTuple::File::isOpen
bool isOpen() const
Access "open" flag.
Definition: NTuple.h:946
MSG::INFO
Definition: IMessageSvc.h:15
Converter::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const
Retrieve pointer to service locator.
Definition: Converter.cpp:92
IOpaqueAddress::ipar
virtual const unsigned long * ipar() const =0
Access to generic link parameters.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
NTuple::File
Small class representing an N tuple file in the transient store.
Definition: NTuple.h:910
Gaudi.Configuration.log
log
Definition: Configuration.py:13

## Member Data Documentation

## ◆ m_compLevel

std::string RootHistCnv::RFileCnv::m_compLevel
| protected

Compression setting, property RFileCnv.GlobalCompression.

Definition at line 45 of file RFileCnv.h.

## ◆ rfile

TFile* RootHistCnv::RFileCnv::rfile
| protected

Pointer to ROOT file.

Definition at line 44 of file RFileCnv.h.

The documentation for this class was generated from the following files:

- RootHistCnv/src/RFileCnv.h
- RootHistCnv/src/RFileCnv.cpp